<?	/*
	// File:	config.inc.php
	// Purpose:	web://cp interface configurations defaults
	// Author:	Felix <webmaster@can-host.com>
	*/
/////////////////////////////////////////////////////////
// General Configurations
//
// Create a file called config.php in webcp's base directory and copy the $cfg values
// you need to change for your system.  Please read INSTALL for detailed instructions.
//
// Tip:  - if you NEED to use a ' symbol, you MUST write it like this: \'
//	 - Either comment configuration that does not apply to you (// $cfg['setting'])
//	   or set no value:  $cfg['setting'] = '';
// System Administrator E-Mail
$cfg['adminmail']	= 'admin@domain.com';
// System Web Name
$cfg['sysname']		= 'localhost';
// root cp server. (localhost|ip_addr|none)
$cfg['root_server']	= '';
// dns://cp server. (localhost|ip_addr|none)
$cfg['dns_server']	= '';
// Base Directory (/home/admin)
$cfg['basedir']		= '/usr/local/webcp';
// Base Web Directory (/home)
$cfg['webdir']		= '/home';
// Web Documents Directory Name (web)
$cfg['webname']		= 'web';
// Cookie security.  Set to false to use web://cp with 'unsafe' cookies.  Set to true when the DNS is set.
$cfg['cookiesec']	= true;
// Log Level: 0 for none, 1 for fatal errors, 2 for +warning, 3 for +activity logging
$cfg['loglevel']	= 2;
// Which log system to use (file|db|filedb|email)
// filedb = file + db
$cfg['log_system']      = 'file';
// Where do you want to save log file
// don't forget to chown
$cfg['logfile']         = '/var/log/webcp';
// Apache central access log file
$cfg['accesslog']	= '/var/log/httpd/access';
// Max allowed updates per domain & user (from 0 to 99)
$cfg['ucount']		= 25;
// Limit Bandwidth via mod_bandwidth (true|false)
$cfg['bandwidth']	= false;
// Server Side Languages (php,asp,perl,ssi,etc)
$cfg['sslang']		= 'php,ssi,perl';
// Supported Languages (lang1,lang2,lang3)
$cfg['lang']		= 'english,french,spanish';
// Default Language (edit carefully)
$cfg['defaultlang']	= 'english';
// Default web interface skin
$cfg['defaultskin']	= 'greenclassic';
// secret crypt key for encryption purpose
$cfg['key']		= 'SECRET_KEY';
// web://cp version
$cfg['webcp']		= '0.5.7';
// configuration options we allow to be changed or added from the front end.
// Do not change unless you know what you're doing
$cfg['allowed_cfg'] 	= 'dbhost|dbuser|dbpass|dbname|sysname|adminmail|os|osversion|defaultlang|key';
/////////////////////////////////////////////////////////
// HTTP Server configuration
// SSL support on httpd-cp (true|false)
$cfg['ssl']		= false;
// httpd-cp listening port (of the dedicated web://cp HTTPD server)
$cfg['port']		= 81;
// apache compatibilty or the webcp built in server (apache|webcp)
$cfg['httpd_mode'] = 'webcp';
// internal port stunnel connects to if ssl is enabled for webcp-httpd
$cfg['ssl_port'] = '83';
// using webcp-httpd should we check php pages for incompatible code (true|false)
$cfg['validate_php'] = true;
// SSL certificate to use with stunnel. use:
// openssl req -new -x509 -nodes -out ssl-cert.pem -keyout ssl-cert.pem -days 365
$cfg['ssl_cert'] = $cfg['basedir'].'/httpd/conf/ssl-cert.pem';
// location of webcp-httpd pid file
$cfg['httpd_pid'] = '/var/run/webcp/webcp-httpd.pid';
// location of stunnel pid file
$cfg['httpsd_pid'] = '/var/run/webcp/webcp-stunel.pid';
// user that webcp-httpd will change to after running
$cfg['httpd_user'] = 'webcp';
// 0.0.0.0 will bind to all local addresses (could also use gethostbyname($cfg['sysname']))
$cfg['listen_address'] = '0.0.0.0';
// The maximum number of backlogged incoming connections to be queued for processing
$cfg['listen_queue'] = '20';
// The maximum number of client connections at once
$cfg['max_clients'] = '20';
// maximum amount of time in seconds to remain connected to a client.
$cfg['timeout'] = '100';
// allow persistent connections? (true|false)
$cfg['keep_alive'] = true;
// keep alive sockets are closed after this many seconds of inactivity
$cfg['keep_alive_timeout'] = '15';
/////////////////////////////////////////////////////////
// Database Configurations
//
// web://cp uses MySQL as its backend, enter the root MySQL access info here.
// MySQL hostname
$cfg['dbhost']		= 'localhost';
// MySQL DB Username
$cfg['dbuser']		= 'root';
// MySQL DB password
$cfg['dbpass']		= 'PASSWORD';
// MySQL DB name
$cfg['dbname']		= 'webcp';
// PostgreSQL configuration.  web://cp can manage it, enter root access info here.
// PostgreSQL Database Host. (localhost|ip_addr|none)
$cfg['pgsql_host']	= '';
// PostgreSQL superuser username.
$cfg['pgsql_user']	= '';
// PostgreSQL superuser's password
$cfg['pgsql_pass']	= 'PASSWORD';
// Default PostgreSQL DB to connect to. (template1)
$cfg['pgsql_db']	= 'template1';
/////////////////////////////////////////////////////////
// System Configurations
//
// OS Type (For OS specific tweaks)
// (linux|freebsd)
$cfg['os']		= 'freebsd';
// OS Version (and distribution)
// -- linux --
// RedHat6.2
// RedHat7.0 - 7.3
// Redhat9.0
// -- freebsd --
// leave empty, not used
$cfg['apache']['port'] = 80;
$cfg['osversion']	= ''; 
// Hard Drive partition holding /home (for HD quotas management)
$cfg['devhd']		= '';  // This is not used in freebsd:
// Network interface to manage IP on
$cfg['eth']		= "fxp0";
// web://cp Daemon PID save location
$cfg['pid']		= '/var/run/webcp/webcp.pid';
// FTP Server (none|wuftpd|proftpd|pureftpd)
$cfg['ftpserver']	= 'proftpd';
// Mailing List support (none|mailman)
$cfg['maillist']	= '';
// PHP libs Location
$cfg['php_lib'] 	= '/usr/local/lib/php:/usr/local/share/pear';
// Invalid users (i.e not in web.cp but elsewhere in the system).  don't trim() spaces
$cfg['badusers']	= ' root toor kmem man smmsp bind xten pop dnscache tinydns dnslog axfrdns bin daemon adm lp sync shutdown halt mail news uucp operator games gopher ftp nobody nscd mailnull ident rpc xfs httpd apache named cp webcp mysql template1 ';
// Program Location
$cfg['prog']['find']	= '/usr/bin/find';
$cfg['prog']['quota']	= '/usr/bin/quota';
$cfg['prog']['free']	= ''; // Not used in freebsd
$cfg['prog']['uptime']	= '/usr/bin/uptime';
$cfg['prog']['walizer'] = '/usr/local/bin/webalizer';
$cfg['prog']['shut']	= '/sbin/shutdown';
$cfg['prog']['makemap']	= ''; // Not used in freebsd
$cfg['prog']['nalias']	= ''; // Not used in freebsd
$cfg['prog']['gadd']	= ''; // Not used in freebsd
$cfg['prog']['gdel']	= ''; // Not used in freebsd
$cfg['prog']['gmod']	= ''; // Not used in freebsd
$cfg['prog']['uadd']	= ''; // Not used in freebsd
$cfg['prog']['udel']	= ''; // Not used in freebsd
$cfg['prog']['umod']	= ''; // Not used in freebsd
$cfg['prog']['squota']	= '/usr/sbin/edquota -e';
$cfg['prog']['cp']	= '/bin/cp';
$cfg['prog']['rm']	= '/bin/rm';
$cfg['prog']['sed']	= '/usr/bin/sed';
$cfg['prog']['chown']	= '/usr/sbin/chown';
$cfg['prog']['shell']	= '/bin/csh';
$cfg['prog']['noshell']	= '/sbin/nologin'; // Make sure this is in /etc/shells!
$cfg['prog']['make']	= '/usr/bin/make';
$cfg['prog']['stunnel']	= '/usr/local/sbin/stunnel';
$cfg['prog']['mysql']	= '/usr/local/bin/mysql';
$cfg['prog']['mm_new']	= '/usr/local/mailman/bin/newlist';
$cfg['prog']['mm_rm']	= '/usr/local/mailman/bin/rmlist -a';
// FreeBSD program
$cfg['prog']['pw']  = '/usr/sbin/pw';
// Pure-FTPD-pw
$cfg['prog']['pureftpd'] 	= '/usr/local/bin/pure-pw';
// qmail/vpopmail
$cfg['vqmail_home']		= '/home/vpopmail';
$cfg['prog']['autorespond']	= '/usr/local/bin/autorespond';
$cfg['prog']['vadddomain']	= $cfg['vqmail_home'].'/bin/vadddomain';
$cfg['prog']['vdeldomain']	= $cfg['vqmail_home'].'/bin/vdeldomain';
$cfg['prog']['vadduser']	= $cfg['vqmail_home'].'/bin/vadduser';
$cfg['prog']['vdeluser']	= $cfg['vqmail_home'].'/bin/vdeluser';
$cfg['prog']['vpasswd']		= $cfg['vqmail_home'].'/bin/vpasswd';
$cfg['prog']['vmoduser']	= $cfg['vqmail_home'].'/bin/vmoduser';
$cfg['prog']['vaddaliasdomain']	= $cfg['vqmail_home'].'/bin/vaddaliasdomain';
$cfg['prog']['vdelivermail']	= $cfg['vqmail_home'].'/bin/vdelivermail';
// authconfig (for crypt or md5 passwords)
$cfg['authconfig'] = '/etc/sysconfig/authconfig';
// Mailman Config
// In order to use it, you will need to apply a small fix to bin/newlist of Mailman. Place a # in front of line 198.
$cfg['mm_wrap']		= '/home/mailman/mail/wrapper';
$cfg['mm_maxlists']	= 5;
// Service stop / start / restart
$cfg['init']['httpd']	= '/usr/local/sbin/apachectl';
$cfg['init']['httpd-cp']	= '/usr/local/sbin/apachectl-cp';
$cfg['init']['sendmail']= ''; // Not used in freebsd
$cfg['init']['named']	= '';// Not used in freebsd
$cfg['init']['qmail']	= '';// Not used in freebsd ???
$cfg['init']['vqmail']	= '';// Not used in freebsd ???
$cfg['init']['pureftpd']= '/usr/local/etc/rc.d/pure-ftpd';
// Service PID (for monitoring)
$cfg['spid']['httpd']	= '/var/run/httpd.pid';
$cfg['spid']['httpd-cp']= '/var/run/httpd-cp.pid';
$cfg['spid']['sendmail']= '/var/run/sendmail.pid';
$cfg['spid']['qmail']	= '';
$cfg['spid']['named']	= '/var/run/named.pid';
$cfg['spid']['proftpd']	= '/var/run/proftpd.pid';
$cfg['spid']['pureftpd']= '/var/run/pureftpd.pid';
$cfg['spid']['wuftpd']	= '/var/run/wuftpd.pid';
$cfg['spid']['pop3']	= '/var/run/inetd.pid';
$cfg['spid']['imap']	= '/var/run/inetd.pid';
$cfg['spid']['sshd']	= '/var/run/sshd.pid';
$cfg['spid']['telnet']	= '';
$cfg['spid']['mysql']	= '/var/run/mysql.pid';
$cfg['spid']['pgsql']	= '/var/run/postmaster.pid';
// Webware support -- Use mod_webkit and have "LoadModule libexec/mod_webkit.so" in your primary httpd.conf
$cfg['webware_dir']	= "webware";
$cfg['webware_init'] 	= "/usr/local/Webware/bin/MakeAppWorkDir.py";
// System log rotate directory (works with cron.daily/logrotate)
$cfg['logdir']		= '/etc/logrotate.d/';
// Server Side HTTP config Location
$cfg['ss']['perl']	= "\tAddHandler cgi-script .cgi .pl\n\t<Directory '%PATH%'>\n\tOptions +ExecCGI\n\t</Directory>";
$cfg['ss']['php']	= "\tphp_admin_flag engine On\n\tphp_admin_value doc_root %PATH%\n\tphp_admin_value safe_mode_exec_dir .:%PATH%\n\tphp_admin_value open_basedir .:/tmp:".$cfg['php_lib'].":%PATH%\n\tAddType application/x-httpd-php .php .php4 .php3 .phtml\n\tAddType application/x-httpd-php-source .phps";
$cfg['ss']['ssi']	= "\tAddType text/html .shtml\n\tAddHandler server-parsed .shtml";
$cfg['ss']['asp'] 	= "\tAddHandler chiliasp .asp .asa";
$cfg['ss']['cfm'] 	= "\tJRunConfig Verbose False\n\tJRunConfig Apialloc false\n\tJRunConfig Ssl false\n\tJRunConfig Ignoresuffixmap true\n\tJRunConfig Serverstore /usr/coldfusionmx/runtime/lib/wsconfig/1/jrunserver.store\n\tJRunConfig Bootstrap 127.0.0.1:51010\n\tAddHandler jrun-handler .cfm .cfc .jsp .cfml .jws";
$cfg['ss']['webware']   = "\t<Location /".$cfg['webware_dir'].">\n\tWKServer localhost 8086\n\tSetHandler webkit-handler\n\t</Location>";
$cfg['ss']['python'] 	= "";
$cfg['ss']['jsp'] 	= "";
// ProFTPD Configurations
// WuFTPd Configurations
// Mail Server (none|sendmail|qmail|virtualqmail)
$cfg['mailserver']	= 'sendmail';
// Sendmail Configurations
$cfg['mail_spool']	= '/var/spool/mail';
$cfg['mail_access']	= '/etc/mail/access';
$cfg['mail_virtuser']	= '/etc/mail/virtusertable';
$cfg['mail_aliases']	= '/etc/aliases';
$cfg['mail_sendmail']   = '/etc/mail/local-host-names';
// Use UQ-IMAP - with black-box mode (true|false)
$cfg['uwimap']		= false;
// UW-IMAP Mailbox Base Directory
$cfg['uwimapdir']	= $cfg['basedir'].'/imap';
// QMail Configurations
$cfg['qmail_rpchosts']	= '/var/qmail/control/rcpthosts'; 
$cfg['qmail_virtdomains']	= '/var/qmail/control/virtualdomains'; 
$cfg['qmail_assign']	= '/var/qmail/users/assign'; 
// Virtual QMail Configurations
$cfg['vqmail_user'] = 'vpopmail';
$cfg['vqmail_group'] = 'vchkpw';
$cfg['vqmail_domains'] = $cfg['vqmail_home'].'/domains';
$cfg['vqmail_postmaster_passwd'] = 'CHANGE_PASSWORD';
$cfg['vqmail_rpchosts'] = $cfg['qmail_rpchosts'];
$cfg['vqmail_virtdomains'] = $cfg['qmail_virtdomains'];
$cfg['vqmail_assign'] = $cfg['qmail_assign'];
/////////////////////////////////////////////////////////
// dns Configurations
//
// Which dns system to use (none|mail|bind|tinydns)
$cfg['dns_system']	= 'mail';
// Directory containing tinydns data file
// ONLY applicable if $cfg["dns_system"] is set to 'tinydns'
$cfg["tinydns_dir"] = '/etc/tinydns';
// Default SOA DNS Settings
// Name Servers - #1 is primary (ns1.domain.com|none)
$cfg['dns_server1']	= 'ns0.domain.com';
$cfg['dns_server2']	= 'ns1.domain.com';
$cfg['dns_server3']	= 'none';
$cfg['dns_server4']	= 'none';
// DNS admin e-mail
$cfg['dns_email']	= 'dns@domain.com';
// Configure below if dns_system is 'bind'
// Allowed zone transfers (from your 'slave' DNS servers) (none|ip address|ip addresses seperated by ;)
$cfg['allow-update']	= 'none';
// Which secondary dns system to use (none|webcp) -- make sure its IP is in 'allow-update'
$cfg['dns2_system'] = 'none';
// Which directory on secondary dns server to use (dnscp) - No ended slash -
$cfg['dns2_dir'] = '/etc/named';
// If dns2_system=webcp which file name to use (ns2.named)
// create the file manualy in webcp/web directory
$cfg['dns2_file'] = 'ns2.named';
// dns2_system=email Secondary DNS Administrator E-Mail
$cfg['dns2_mail'] = $cfg['adminmail'];
// DNS Refresh (10800)
$cfg['dns_refresh']	= 10800;
// DNS Retry (3600)
$cfg['dns_retry']	= 3600;
// DNS Time To Live (86400)
$cfg['dns_ttl']		= 86400;
// DNS Expire (604800)
$cfg['dns_expire']	= 604800;
// Reverse Records IP Mask
$cfg['dns_ipmask']	= 24;
/////////////////////////////////////////////////////////
// Mail Exchangers
//
// specify up to four mail exchangers to use with webcp
// IN ORDER OF PREFERENCE:
$cfg['mail_exchanger1'] = "mx1.example.com";
$cfg['mail_exchanger2'] = 'none';
$cfg['mail_exchanger3'] = 'none';
$cfg['mail_exchanger4'] = 'none';
// CONFIGURATION ENDS HERE
/////////////////////////////////////////////////////////
// check for the existence of a custom config.php file
$tmpcfg = explode("/",__FILE__);
array_pop($tmpcfg);array_pop($tmpcfg);
$tmpcfg = implode("/",$tmpcfg)."/config.php";
if (file_exists($tmpcfg))
	include($tmpcfg);
?>
