%define ver 0.5.7

%define install_dir /home/webcp



Summary: A web based hosting control panel

Name: webcp

Version: %{ver}

Release: 1

License: GPL

URL: http://www.web-cp.net

Group: System/Tools



Requires(pre,postun): shadow-utils, sed, quota

Requires(post,preun): chkconfig

Requires(post): textutils, fileutils



BuildRoot: %{_tmppath}/%{name}-root

BuildArchitectures: noarch



Source: http://www.web-cp.net/%{name}.%{version}.tar.gz



%description

web://cp is an open source web hosting control panel for Unix systems.

It is comprised of 4 interconnected modules that can be accessed through

a web browser and used to administrate the client, domain, reseller and

server aspects of web hosting. It is developed in

PHP and is designed to be portable.





%prep

%setup -q -n %{name}





%build





%install

[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}



mkdir -p %{buildroot}%{install_dir}

mkdir -p %{buildroot}/var/run/webcp

mkdir -p %{buildroot}/etc/init.d



mv server/webcp-init.php %{buildroot}/etc/init.d/webcp

cp -rp * %{buildroot}%{install_dir}





%clean

[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}





%files

%defattr(755, root, webcp)

%attr(755, webcp, webcp) /var/run/webcp

%attr(755, root, root) /etc/init.d/webcp

%{install_dir}

%attr(777, root, webcp) %{install_dir}/autoresponder

%attr(750, root, webcp) %{install_dir}/headers

%attr(750, root, webcp) %{install_dir}/server

%attr(755, root, webcp) %dir %{install_dir}/server

%attr(755, root, webcp) %dir %{install_dir}/server/autoreply.php

%attr(700, root, webcp) %{install_dir}/skel

%attr(770, root, webcp) %{install_dir}/tag

%attr(750, root, webcp) %{install_dir}/web

%config(noreplace) %{install_dir}/web/config.inc.php

%doc %{install_dir}/httpd/README

%doc %{install_dir}/imap/README

%doc %{install_dir}/named/README

%doc %{install_dir}/DEVELOPER

%doc %{install_dir}/FEATURES

%doc %{install_dir}/HELP

%doc %{install_dir}/INSTALL

%doc %{install_dir}/LICENSE

%doc %{install_dir}/MAILMAN

%doc %{install_dir}/TODO

%doc %{install_dir}/UPDATE-INFO





%pre

# check if php is installed correctly #

php_bin=`which php 2>/dev/null`

if [ ! -r "$php_bin" ]; then

	echo "warning: PHP is not installed correctly (compile once as a standalone binary, without '--with-apxs')"

else

	if [ `$php_bin -m | grep -c ^ftp 2>/dev/null` == 0 ]; then

		echo "warning: The PHP FTP module is required (configure PHP '--enable-ftp')"

	fi



	if [ `$php_bin -m | grep -c ^mysql 2>/dev/null` == 0 ]; then

		echo "warning: The PHP MySQL module is required (configure PHP '--with-mysql=/usr')"

	fi



	if [ `$php_bin -m | grep -c ^pcre 2>/dev/null` == 0 ]; then

		echo "warning: The PHP Perl Compatible Regular Expressions module is required (configure PHP '--with-pcre-regex')"

	fi



	if [ `$php_bin -m | grep -c ^posix 2>/dev/null` == 0 ]; then

		echo "warning: The PHP POSIX module is required (configure PHP '--enable-posix')"

	fi



	if [ `$php_bin -m | grep -c ^pcntl 2>/dev/null` == 0 ]; then

		echo "warning: The PHP Process Control module is required (configure PHP '--enable-pcntl')"

	fi



	if [ `$php_bin -m | grep -c ^sockets 2>/dev/null` == 0 ]; then

		echo "warning: The PHP Sockets module is required (configure PHP '--enable-sockets')"

	fi



	if [ `$php_bin -m | grep -c ^zlib 2>/dev/null` == 0 ]; then

		echo "warning: The PHP Zlib module is required (configure PHP '--with-zlib-dir=/usr')"

	fi

fi



# create webcp user #

/usr/sbin/useradd -u 90 -s /sbin/nologin -d %{install_dir} -c "webcp user" webcp 2>/dev/null || :



# make sure log file exists and has correct permissions #

touch /var/log/webcp

chown webcp.webcp /var/log/webcp

chmod 600 /var/log/webcp



# apache needs to use the domain data from webcp #

if [ -r /etc/httpd/conf/httpd.conf ]; then

	httpd_include=`cat /etc/httpd/conf/httpd.conf | grep 'Include %{install_dir}' 2>/dev/null`

	if [ "$httpd_include" == "" ]; then

		echo "Include %{install_dir}/httpd/include/include.httpd" >> /etc/httpd/conf/httpd.conf

	fi

fi



# dns server needs to use the domain data from webcp #

if [ -r /etc/named.conf ]; then

	named_include=`cat /etc/named.conf | grep -i 'Include "%{install_dir}' 2>/dev/null`

	if [ "$named_include" == "" ]; then

		echo "Include \"%{install_dir}/named/include/include.named\";" >> /etc/named.conf

	fi

fi



# attempt to enable quotas #

grep '/home' /etc/fstab > /dev/null

if [ $? == 0 ]; then

	grep 'LABEL=/home .*usrquota\|grpquota' /etc/fstab > /dev/null

	if [ $? != 0 ]; then

		sed -e '/LABEL=\/home /s/defaults/defaults,usrquota,grpquota/' /etc/fstab > /tmp/fstab

		sed_return=$?

		mv -f /tmp/fstab /etc/fstab

		mount -o remount /home

	fi

else

	grep 'LABEL=/ .*usrquota\|grpquota' /etc/fstab > /dev/null

	if [ $? != 0 ]; then

		sed -e '/LABEL=\/ /s/defaults/defaults,usrquota,grpquota/' /etc/fstab > /tmp/fstab

		sed_return=$?

		mv -f /tmp/fstab /etc/fstab

		mount -o remount /

	fi

fi



if [ "$sed_return" == 0 ] ; then

	quotacheck -acvugM

fi





%post

# start web://cp #

/sbin/chkconfig --add webcp

if [ -r /usr/bin/php ]; then

	/etc/init.d/webcp start > /dev/null

fi

echo "Web://cp has been installed. Please browse to http://localhost:81 to continue setup."





%preun

# make sure webcp isn't still running #

if [ -r /usr/bin/php ]; then

	/etc/init.d/webcp stop > /dev/null

fi

/sbin/chkconfig --del webcp





%postun

# remove user and group

/usr/sbin/userdel webcp 2>/dev/null || :

/usr/sbin/groupdel webcp 2>/dev/null || :



# attempt to disable quotas #

grep '/home' /etc/fstab > /dev/null

if [ $? == 0 ]; then

	sed -e '/LABEL=\/home /s/defaults,usrquota,grpquota/defaults/' /etc/fstab > /tmp/fstab

	mv -f /tmp/fstab /etc/fstab

	mount -o remount /home

else

	sed -e '/LABEL=\/ /s/defaults,usrquota,grpquota/defaults/' /etc/fstab > /tmp/fstab

	mv -f /tmp/fstab /etc/fstab

	mount -o remount /

fi





%changelog

* Mon Aug 4 2003 Jonathan Haskins <jhaskins@killobyte.com>

- try to enable quotas



* Mon Jun 12 2003 Jonathan Haskins <jhaskins@killobyte.com>

- added php + module detection and some other fixes



* Mon Jun 09 2003 Jonathan Haskins <jhaskins@killobyte.com>

- initial build

